module ApiBackend
  module APIRequests
    def api_get(endpoint, data={})
      get endpoint, data.to_json, api_headers
    end

    def api_post(endpoint, data = {})
      post endpoint, data.to_json, api_headers
    end

    def api_patch(endpoint, data = {})
      patch endpoint, data.to_json, api_headers
    end

    def api_headers
      headers = { 'Content-Type' => 'application/json' }
      headers["Authorization"] =  "Token token=#{@auth_token}" if @auth_token

      headers
    end

    def login(user = User.last)
      user = create(:user) unless user
      @current_user = user
      @auth_token = user.auth_token
    end

    def current_user
      @current_user
    end
  end
end

RSpec.configure do |config|
  config.include ApiBackend::APIRequests
end