shared_examples "an unauthorized resourse" do
  it 'returns an status 401' do
    expect(response.code.to_i).to eq 401
  end

  it 'returns a WWW-Authenticate header' do
    expect(response.headers['WWW-Authenticate']).to eq('Token realm="Application"')
  end
  
  it 'returns a json response' do
    expect(response.headers['Content-Type']).to include('application/json')
  end
end

shared_examples 'an invalid resource' do
  it 'returns a 422 status' do
    expect(response.code.to_i).to eq 422      
  end

  it 'returns errors' do
    expect(response_json['errors']).to_not be_empty
  end
end