shared_examples 'a createable resource' do
  context 'with a valid resource' do
    let(:latest_resource) { resource_class.all.last }
    before do
      resource
      api_post endpoint, valid_attributes
    end

    it 'creates the resource' do
      expect(latest_resource).to_not be_nil
    end

    it 'returns the created resource' do
      json_keys.each do |key|
        expect(response_json[key.to_s]).to eq(latest_resource.send(key))
      end
    end

    it 'returns a status 200' do
      expect(response.code.to_i).to be(200)
    end
  end

  context 'with invalid resource attributes' do
    before do
      api_post endpoint
    end

    it_behaves_like 'an invalid resource'
  end
end