shared_examples 'an updateable resource' do
  context 'with a valid resource' do
    before do
      resource
      api_patch endpoint, valid_attributes
      resource.reload
    end

    it 'updates the resource' do
      valid_attributes.each_pair do |key, value|
        expect(resource.send(key)).to eq(value)
      end
    end

    it 'returns the correct resource' do
      json_keys.each do |key|
        expect(response_json[key.to_s]).to eq(resource.send(key))
      end
    end

    it 'returns a starus 200' do
      expect(response.code.to_i).to be(200)
    end
  end

  context 'with an invalid resource' do
    before do
      resource
      api_patch endpoint, invalid_attributes
    end
    it_behaves_like 'an invalid resource'
  end
end